#include<bits/stdc++.h>
using namespace std;
unsigned long long prefsum[200050], stek, tren;
int n,q;
int d[200050], p[200050];
int mini, maks, sred;
bool pr1, pr2;

int main ()
{
    scanf("%d %d", &n, &q);
    pr1 = 0;
    pr2 = 0;
    for(int i=1; i<=n; i++)
    {
        scanf("%lld %lld", &d[i], &p[i]);
        tren = p[i] * (n-i+1); /// OVOLIKO DMG CE DOPRINETI POISON
        if(d[i] >= tren)
        {
            prefsum[i] = prefsum[i-1] + stek + d[i];
            ///IZVEDI OBICAN;
        }

        else ///INACE
        {
            prefsum[i] = prefsum[i-1] + stek + p[i];
            stek += p[i]; /// OVOLIKO SE STEKUJE DMG
        }
    }
    for(int i=1; i<=q; i++)
    {
        long long h;
        scanf("%lld", &h);
        if(prefsum[n] < h)
            printf("-1 \n");
        else
        {
            mini = 1;
            maks = n;
            sred = 0;
            while(mini <= maks)
            {
                sred = (mini+maks)/2;
                if(prefsum[sred] >= h and prefsum[sred-1] < h)
                    printf("%d \n", sred);
                if(prefsum[sred] >= h)
                    maks = sred-1;
                if(prefsum[sred] < h)
                    mini = sred+1;
            }
        }
    }
    return 0;
}
/*
3 5
3 0
4 0
5 0
3
4
5
13
2

*/